Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ensembl.driver
Interface AssemblyExceptionAdaptor

All Superinterfaces:
  Adaptor, java.rmi.Remote

public interface AssemblyExceptionAdaptor
extends Adaptor

Adaptor for retrieving and handling AssemblyExceptions which are used to represent PARs and haplotypes.

PAR/haplotype sequences can be thought of as series of sequence region chunks. Some of these chunks are specific to the PAR/Haplotype and others are links to parts of "reference" chromosomes. e.g. DR52 consists of sequence regions unique to DR52 and chunks of reference chromosome 6.

As an optimisation Ensembl databases do not store duplicate sequence and features for the regions PAR/haplotypes share with "reference" chromosomes. Instead they store the links between these chunks as AssemblyLocations. This information can be used to retrieving sequence and features for the PARs/Haplotypes that is stored "on" the the reference sequence.

A location on a shared region of a PAR/Haplotype can be converted between the PAR/Haplotype and reference chromosomes via dereference(Location) and reference(Location, String).

See Also:
  `AssemblyException`, `dereference(Location)`, `rereference(Location, SequenceRegion)`

Field Summary
`static java.lang.String` | `TYPE`

Method Summary
`Location` | `dereference(Location loc)` Dereferences the request location.
`java.util.List` | `fetch()` Retrieve all AssemblyExceptions.
`java.util.List` | `fetch(Location loc)` Retrieve AssemblyExceptions that are relevant for given location.
`AssemblyException` | `fetch(long internalID)` Retrieve AssemblyException with specified internalID.
`boolean` | `hasReferences(Location loc)` Determines whether loc includes references to other locations.
`Location` | `rereference(Location loc, SequenceRegion targetSeqRegion)` Refereferences the source locations.

Methods inherited from interface org.ensembl.driver.Adaptor
`clearCache, closeAllConnections, getType`

Field Detail

### TYPE

    public static final java.lang.String TYPE

See Also:
  Constant Field Values

Method Detail

### fetch

    public java.util.List fetch()
                         throws AdaptorException

  Retrieve all AssemblyExceptions.

  Returns:
    all AssemblyExceptions
  Throws:
    `AdaptorException`

### fetch

    public AssemblyException fetch(long internalID)
                            throws AdaptorException

  Retrieve AssemblyException with specified internalID.

  Parameters:
    `internalID` - internal ID of the assembly location
  Returns:
    AssemblyException assembly exception with specified internal ID or null if none found.
  Throws:
    `AdaptorException`

### fetch

    public java.util.List fetch(Location loc)
                         throws AdaptorException

  Retrieve AssemblyExceptions that are relevant for given location.

  They have to be on the same sequence region with their linked Location.

  Parameters:
    `loc` -
  Returns:
    zero or more AssemblyExceptions that overlap the given location
  Throws:
    `AdaptorException`

### dereference

    public Location dereference(Location loc)
                         throws AdaptorException

  Dereferences the request location. Features for some seq regions , e.g. human chromosome:DR51, are stored in chunks where some of the chunks are actually references to other sequence regions e.g. chromosome:6. e.g. chromosome:DR51 -> [chromosome:6:1-b, chromosome:DR51:1-c, chromosome:6:d-end]

  Parameters:
    `loc` - location (list) to be dereferenced.
  Returns:
    location (list) corresponding to loc containing one or more nodes, or null if no mapping is possible.
  Throws:
    `AdaptorException`
  See Also:
    `rereference(Location, SequenceRegion)`, `hasReferences(Location)`

### rereference

    public Location rereference(Location loc,
                                SequenceRegion targetSeqRegion)
                         throws AdaptorException

  Refereferences the source locations. Maps the locations into the specified coordinate system and target sequence name if possible. e.g. [chromosome:6:1-b, chromosome:DR51:1-c, chromosome:6:d-end] -> chromosome:DR51

  Parameters:
    `loc` - source location (list) to be rereferenced
    `targetSeqRegion` - sequence region to convert locations into (if necessary)
  Returns:
    location (list) on targetSeqRegion, or null if a mapping is not possible.
  Throws:
    `AdaptorException`
  See Also:
    `hasReferences(Location)`

### hasReferences

    public boolean hasReferences(Location loc)
                          throws AdaptorException

  Determines whether loc includes references to other locations.

  Parameters:
    `loc` - location to test.
  Returns:
    true if loc contains references, otherwise false.
  Throws:
    `AdaptorException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD